import antpanic
import random

food_types = ['apple', 'cake', 'chicken', 'jelly', 'sandwich', 'strawberry', 'wine']

class Level(object):
    ant_speed_inc = 0.4
    anthill_num_inc = 0.4
    max_ants_inc = 2
    food_inc = 1

    def __init__(self, game):
        self.game = game

        self.level_num = 0
        self.available_food = 3
        self.required_food = 1
        self.ant_speed = 1.0 
        self.max_ants = 15

        self.num_anthills = 0.3 
        self.anthills = []

    def next_level(self):
        self.level_num += 1

        self.ant_speed += self.ant_speed_inc
        self.max_ants += self.max_ants_inc

        self.available_food += self.food_inc

        if self.level_num <= 5:
            self.required_food = self.available_food - 2
        elif self.level_num <= 10:
            self.required_food = self.available_food - 1
        else:
            self.required_food = self.available_food - 0

        self.num_anthills += self.anthill_num_inc
        self.addAnthills(int(round(self.num_anthills)), self.max_ants)
        self.addFoods(int(round(self.available_food)))

    def addAnthills(self, num, max_ants):
        self.anthills = []

        for x in range(num):
            anthill = antpanic.AntHill(self)

            while 1:
                anthill.x = random.randint(20, 715)
                anthill.y = random.randint(110, 525)

                if (anthill.x > 170 and anthill.x < 560
                    and anthill.y > 170 and anthill.y < 460):
                    continue

                overlap = False
                for chk_hill in self.anthills:
                    if chk_hill.get_rect().colliderect(anthill.get_rect()):
                        overlap = True

                if not overlap: break

            anthill.max_ants = max_ants
            self.anthills.append(anthill)

    def addFoods(self, num):
        self.foods = []

        for x in range(num):
            food = antpanic.Food(self, random.choice(food_types))

            while 1: 
                food.x = food.round_x = random.randint(258, 258+268)
                food.y = food.round_y = random.randint(258, 258+144)

                overlap = False
                for chk_food in self.foods:
                    if chk_food.get_rect().colliderect(food.get_rect()):
                        overlap = True

                if not overlap: break

            self.foods.append(food)
